#include "lcd.h"
#include "stdlib.h"
#include "font.h" 
#include "usart.h"	 
#include "delay.h"	 
#include "ltdc.h"
//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//ALIENTEK STM32
//2.8/3.5/4.3/7 TFTҺ	  
//֧ICͺŰ:ILI9341/NT35310/NT35510/SSD1963		    
//ԭ@ALIENTEK
//̳:www.openedv.com
//:2016/1/6
//汾V1.0
//ȨУؾ
//Copyright(C) ӿƼ޹˾ 2014-2024
//All rights reserved	 
//////////////////////////////////////////////////////////////////////////////////	 
//˵
//V1.1
//RGBLCD֧(ʹLTDC).
//////////////////////////////////////////////////////////////////////////////////	 

SRAM_HandleTypeDef SRAM_Handler;    //SRAM(ڿLCD)
//LCDĻɫͱɫ	   
u32 POINT_COLOR=0xFF000000;		//ɫ
u32 BACK_COLOR =0xFFFFFFFF;  	//ɫ 
  
//LCDҪ
//ĬΪ
_lcd_dev lcddev;
	 
//дĴ
//regval:Ĵֵ
void LCD_WR_REG(vu16 regval)
{   
	regval=regval;		//ʹ-O2Żʱ,ʱ
	LCD->LCD_REG=regval;//дҪдļĴ	 
}
//дLCD
//data:Ҫдֵ
void LCD_WR_DATA(vu16 data)
{	  
	data=data;			//ʹ-O2Żʱ,ʱ
	LCD->LCD_RAM=data;		 
}
//LCD
//ֵ:ֵ
u16 LCD_RD_DATA(void)
{
	vu16 ram;			//ֹŻ
	ram=LCD->LCD_RAM;	
	return ram;	 
}					   
//дĴ
//LCD_Reg:Ĵַ
//LCD_RegValue:Ҫд
void LCD_WriteReg(u16 LCD_Reg,u16 LCD_RegValue)
{	
	LCD->LCD_REG = LCD_Reg;		//дҪдļĴ	 
	LCD->LCD_RAM = LCD_RegValue;//д	    		 
}	   
//Ĵ
//LCD_Reg:Ĵַ
//ֵ:
u16 LCD_ReadReg(u16 LCD_Reg)
{										   
	LCD_WR_REG(LCD_Reg);		//дҪļĴ
	delay_us(5);		  
	return LCD_RD_DATA();		//ضֵ
}   
//ʼдGRAM
void LCD_WriteRAM_Prepare(void)
{
 	LCD->LCD_REG=lcddev.wramcmd;	  
}	 
//LCDдGRAM
//RGB_Code:ɫֵ
void LCD_WriteRAM(u16 RGB_Code)
{							    
	LCD->LCD_RAM = RGB_Code;//дʮλGRAM
}
//ILI93xxΪGBRʽдʱΪRGBʽ
//ͨúת
//c:GBRʽɫֵ
//ֵRGBʽɫֵ
u16 LCD_BGR2RGB(u16 c)
{
	u16  r,g,b,rgb;   
	b=(c>>0)&0x1f;
	g=(c>>5)&0x3f;
	r=(c>>11)&0x1f;	 
	rgb=(b<<11)+(g<<5)+(r<<0);		 
	return(rgb);
} 
//mdk -O1ʱŻʱҪ
//ʱi
void opt_delay(u8 i)
{
	while(i--);
}
//ȡĳɫֵ	 
//x,y:
//ֵ:˵ɫ
u32 LCD_ReadPoint(u16 x,u16 y)
{
 	u16 r=0,g=0,b=0;
	if(x>=lcddev.width||y>=lcddev.height)return 0;	//˷Χ,ֱӷ
	if(lcdltdc.pwidth!=0)							//RGB
	{
		return LTDC_Read_Point(x,y);
	}
	LCD_SetCursor(x,y);	    
	if(lcddev.id==0X9341||lcddev.id==0X5310||lcddev.id==0X1963)LCD_WR_REG(0X2E);//9341/3510/1963 ͶGRAMָ
	else if(lcddev.id==0X5510)LCD_WR_REG(0X2E00);	//5510 ͶGRAMָ
 	r=LCD_RD_DATA();								//dummy Read	   
	if(lcddev.id==0X1963)return r;					//1963ֱӶͿ 
	opt_delay(2);	  
 	r=LCD_RD_DATA();  		  						//ʵɫ
	//9341/NT35310/NT35510Ҫ2ζ 
	opt_delay(2);	  
	b=LCD_RD_DATA(); 
	g=r&0XFF;		//9341/5310/5510,һζȡRGֵ,Rǰ,Gں,ռ8λ
	g<<=8; 
	return (((r>>11)<<11)|((g>>10)<<5)|(b>>11));	//ILI9341/NT35310/NT35510Ҫʽתһ
}			 
//LCDʾ
void LCD_DisplayOn(void)
{					   
	if(lcdltdc.pwidth!=0)LTDC_Switch(1);//LCD
	else if(lcddev.id==0X9341||lcddev.id==0X5310||lcddev.id==0X1963)LCD_WR_REG(0X29);	//ʾ
	else if(lcddev.id==0X5510)LCD_WR_REG(0X2900);	//ʾ
}	 
//LCDرʾ
void LCD_DisplayOff(void)
{	   
	if(lcdltdc.pwidth!=0)LTDC_Switch(0);//رLCD
	else if(lcddev.id==0X9341||lcddev.id==0X5310||lcddev.id==0X1963)LCD_WR_REG(0X28);	//رʾ
	else if(lcddev.id==0X5510)LCD_WR_REG(0X2800);	//رʾ
}   
//ùλ(RGBЧ)
//Xpos:
//Ypos:
void LCD_SetCursor(u16 Xpos, u16 Ypos)
{	 
 	if(lcddev.id==0X9341||lcddev.id==0X5310)
	{		    
		LCD_WR_REG(lcddev.setxcmd); 
		LCD_WR_DATA(Xpos>>8);LCD_WR_DATA(Xpos&0XFF); 			 
		LCD_WR_REG(lcddev.setycmd); 
		LCD_WR_DATA(Ypos>>8);LCD_WR_DATA(Ypos&0XFF); 		
	}else if(lcddev.id==0X1963)
	{  			 		
		if(lcddev.dir==0)//xҪ任
		{
			Xpos=lcddev.width-1-Xpos;
			LCD_WR_REG(lcddev.setxcmd); 
			LCD_WR_DATA(0);LCD_WR_DATA(0); 		
			LCD_WR_DATA(Xpos>>8);LCD_WR_DATA(Xpos&0XFF);		 	 
		}else
		{
			LCD_WR_REG(lcddev.setxcmd); 
			LCD_WR_DATA(Xpos>>8);LCD_WR_DATA(Xpos&0XFF); 		
			LCD_WR_DATA((lcddev.width-1)>>8);LCD_WR_DATA((lcddev.width-1)&0XFF);		 	 			
		}	
		LCD_WR_REG(lcddev.setycmd); 
		LCD_WR_DATA(Ypos>>8);LCD_WR_DATA(Ypos&0XFF); 		
		LCD_WR_DATA((lcddev.height-1)>>8);LCD_WR_DATA((lcddev.height-1)&0XFF); 			 		
		
	}else if(lcddev.id==0X5510)
	{
		LCD_WR_REG(lcddev.setxcmd);LCD_WR_DATA(Xpos>>8); 		
		LCD_WR_REG(lcddev.setxcmd+1);LCD_WR_DATA(Xpos&0XFF);			 
		LCD_WR_REG(lcddev.setycmd);LCD_WR_DATA(Ypos>>8);  		
		LCD_WR_REG(lcddev.setycmd+1);LCD_WR_DATA(Ypos&0XFF);			
	} 
} 		 
//LCDԶɨ跽(RGBЧ)
//ע:ܻܵ˺õӰ(9341),
//,һΪL2R_U2D,Ϊɨ跽ʽ,ܵʾ.
//dir:0~7,8(嶨lcd.h)
//9341/5310/5510/1963ICѾʵʲ	   	   
void LCD_Scan_Dir(u8 dir)
{
	u16 regval=0;
	u16 dirreg=0;
	u16 temp;  
	if((lcddev.dir==1&&lcddev.id!=0X1963)||(lcddev.dir==0&&lcddev.id==0X1963))//ʱ1963ıɨ跽ʱ1963ı䷽
	{			   
		switch(dir)//ת
		{
			case 0:dir=6;break;
			case 1:dir=7;break;
			case 2:dir=4;break;
			case 3:dir=5;break;
			case 4:dir=1;break;
			case 5:dir=0;break;
			case 6:dir=3;break;
			case 7:dir=2;break;	     
		}
	} 
	if(lcddev.id==0x9341||lcddev.id==0X5310||lcddev.id==0X5510||lcddev.id==0X1963)//9341/5310/5510/1963,⴦
	{
		switch(dir)
		{
			case L2R_U2D://,ϵ
				regval|=(0<<7)|(0<<6)|(0<<5); 
				break;
			case L2R_D2U://,µ
				regval|=(1<<7)|(0<<6)|(0<<5); 
				break;
			case R2L_U2D://ҵ,ϵ
				regval|=(0<<7)|(1<<6)|(0<<5); 
				break;
			case R2L_D2U://ҵ,µ
				regval|=(1<<7)|(1<<6)|(0<<5); 
				break;	 
			case U2D_L2R://ϵ,
				regval|=(0<<7)|(0<<6)|(1<<5); 
				break;
			case U2D_R2L://ϵ,ҵ
				regval|=(0<<7)|(1<<6)|(1<<5); 
				break;
			case D2U_L2R://µ,
				regval|=(1<<7)|(0<<6)|(1<<5); 
				break;
			case D2U_R2L://µ,ҵ
				regval|=(1<<7)|(1<<6)|(1<<5); 
				break;	 
		}
		if(lcddev.id==0X5510)dirreg=0X3600;
		else dirreg=0X36;
 		if((lcddev.id!=0X5310)&&(lcddev.id!=0X5510)&&(lcddev.id!=0X1963))regval|=0X08;//5310/5510/1963ҪBGR   
 		LCD_WriteReg(dirreg,regval);
		if(lcddev.id!=0X1963)//1963괦
		{
			if(regval&0X20)
			{
				if(lcddev.width<lcddev.height)//X,Y
				{
					temp=lcddev.width;
					lcddev.width=lcddev.height;
					lcddev.height=temp;
				}
			}else  
			{
				if(lcddev.width>lcddev.height)//X,Y
				{
					temp=lcddev.width;
					lcddev.width=lcddev.height;
					lcddev.height=temp;
				}
			}  
		}
		if(lcddev.id==0X5510)
		{
			LCD_WR_REG(lcddev.setxcmd);LCD_WR_DATA(0); 
			LCD_WR_REG(lcddev.setxcmd+1);LCD_WR_DATA(0); 
			LCD_WR_REG(lcddev.setxcmd+2);LCD_WR_DATA((lcddev.width-1)>>8); 
			LCD_WR_REG(lcddev.setxcmd+3);LCD_WR_DATA((lcddev.width-1)&0XFF); 
			LCD_WR_REG(lcddev.setycmd);LCD_WR_DATA(0); 
			LCD_WR_REG(lcddev.setycmd+1);LCD_WR_DATA(0); 
			LCD_WR_REG(lcddev.setycmd+2);LCD_WR_DATA((lcddev.height-1)>>8); 
			LCD_WR_REG(lcddev.setycmd+3);LCD_WR_DATA((lcddev.height-1)&0XFF);
		}else
		{
			LCD_WR_REG(lcddev.setxcmd); 
			LCD_WR_DATA(0);LCD_WR_DATA(0);
			LCD_WR_DATA((lcddev.width-1)>>8);LCD_WR_DATA((lcddev.width-1)&0XFF);
			LCD_WR_REG(lcddev.setycmd); 
			LCD_WR_DATA(0);LCD_WR_DATA(0);
			LCD_WR_DATA((lcddev.height-1)>>8);LCD_WR_DATA((lcddev.height-1)&0XFF);  
		}
  	} 
}     
//
//x,y:
//POINT_COLOR:˵ɫ
void LCD_DrawPoint(u16 x,u16 y)
{
	if(lcdltdc.pwidth!=0)//RGB
	{
		LTDC_Draw_Point(x,y,POINT_COLOR);
	}else
	{
		LCD_SetCursor(x,y);		//ùλ 
		LCD_WriteRAM_Prepare();	//ʼдGRAM
		LCD->LCD_RAM=POINT_COLOR; 
	}
}


//ʾ߿ͼƬ
//LCDֱΪH*V,ɫΪbackground,߿ɫΪcolor
void display_HDBK(u16 H, u16 V, u32 background, u32 color)
{
	 u16 x,y ;
    for( x = 0 ; x < H ; x++ )	
    	 {	
						LTDC_Draw_Point(x,0,color);				 
			 }		
		
    for( y = 1 ; y < (V-1) ; y++ )
    
       {
						LTDC_Draw_Point(0,y,color);				 
    for( x = 1 ; x < (H-1) ; x++ )
    	
    	 {					
						LTDC_Draw_Point(x,y,background);				 	
    	 }		
						LTDC_Draw_Point((H-1),y,color);	
    	 }
    	
     for( x = 0 ; x < H ; x++ )
    	
    	{				
						LTDC_Draw_Point(x,(V-1),color);
    	}		

 
}


//ʾˮƽ
void display_colorbar_H(void)
	
{   u16 x,y;
		
	for( y = 0 ; y < 60 ; y++ )
	  for( x = 0 ; x < 800 ; x++ )
	     {
				 LTDC_Draw_Point(x,y,0xf800);
			 }
	
	for( y = 60 ; y < 120 ; y++ )
	  for( x = 0 ; x < 800 ; x++ )
	     {
				 LTDC_Draw_Point(x,y,0x07E0);
			 }
			 
			 
	for( y = 120 ; y < 180 ; y++ )
	  for( x = 0 ; x < 800 ; x++ )
	     {
				 LTDC_Draw_Point(x,y,0x001F);
			 }	 
			 
			 
	for( y = 180 ; y < 240 ; y++ )
	  for( x = 0 ; x < 800 ; x++ )
	     {
				 LTDC_Draw_Point(x,y,0xFFE0);
			 }			 
			 
	for( y = 240 ; y < 300 ; y++ )
	  for( x = 0 ; x < 800 ; x++ )
	     {
				 LTDC_Draw_Point(x,y,0x07FF);
			 }			 
			 
	for( y = 300 ; y < 360 ; y++ )
	  for( x = 0 ; x < 800 ; x++ )
	     {
				 LTDC_Draw_Point(x,y,0xF81F);
			 }	
	for( y = 360 ; y < 420 ; y++ )
	  for( x = 0 ; x < 800 ; x++ )
	     {
				 LTDC_Draw_Point(x,y,0xFFFF);
			 }	
	for( y = 420 ; y < 480 ; y++ )
	  for( x = 0 ; x < 800 ; x++ )
	     {
				 LTDC_Draw_Point(x,y,0x0000);
			 }		 		 
}


//ʾֱ
void display_colorbar_V(void)
	
{   u16 x,y;
		
	for( y = 0 ; y < 480 ; y++ )
	
	   {
	  for( x = 0 ; x < 100 ; x++ )
	     {
				 LTDC_Draw_Point(x,y,0xf800);
			 }
			 
		for( x = 100 ; x < 200 ; x++ )
	     {
				 LTDC_Draw_Point(x,y,0x07E0);
			 }
		for( x = 200 ; x < 300 ; x++ )
	     {
				 LTDC_Draw_Point(x,y,0x001F);
			 }	
		for( x = 300 ; x < 400 ; x++ )
	     {
				 LTDC_Draw_Point(x,y,0xFFE0);
			 }		 
		for( x = 400 ; x < 500 ; x++ )
	     {
				 LTDC_Draw_Point(x,y,0x07FF);
			 }
		for( x = 500 ; x < 600 ; x++ )
	     {
				 LTDC_Draw_Point(x,y,0xF81F);
			 }		
		for( x = 600 ; x < 700 ; x++ )
	     {
				 LTDC_Draw_Point(x,y,0xFFFF);
			 }		
		for( x = 700 ; x < 800 ; x++ )
	     {
				 LTDC_Draw_Point(x,y,0x0000);
			 }		
		 }			 

}


//ʾڰ̸
//LCDֱΪH*V
//̸ĴСΪM*N
void qipan_display1(u16 H, u16 V, u8 M, u8 N)
{
  u16 x=0,y=0;
  u8 i,j;
  for(j=0;j<(V/(M+N));j++)   
  {
		for(y=(M+N)*j;y<((M+N)*j+M);y++)
			{
				for(i=0;i<(H/(M+N));i++)
					{
						for(x=(M+N)*i;x<((M+N)*i+M);x++)
							{    
								LTDC_Draw_Point(x,y,0x0000);					
							}
						for(x=((M+N)*i+M);x<((M+N)*i+(M+N));x++)
							{      
								LTDC_Draw_Point(x,y,0xFFFF);					
							}
					}
			 }
 for(y=((M+N)*j+N);y<((M+N)*j+(M+N));y++)
	{
		for(i=0;i<(H/(M+N));i++)      
			{
				for(x=((M+N)*i);x<((M+N)*i+M);x++)
					{      
						LTDC_Draw_Point(x,y,0xFFFF);					
					}
				for(x=((M+N)*i+M);x<((M+N)*i+(M+N));x++)
					{   		
						LTDC_Draw_Point(x,y,0x0000);	
					}
			}
	}
  }
}


void qipan_display2(void)// H=480  V=800  M=80  N=80
{
  u32 x,y;
  u8 i,j;
  for(j=0;j<3;j++)   
  {
		for(y=160*j;y<160*j+80;y++)
    {
			for(i=0;i<6;i++)
      {
				for(x=160*i;x<160*i+80;x++)
        {   
						LTDC_Draw_Point(y,x,0x0000);  
		    }
				for(x=160*i+80;x<160*i+160;x++)
        {      
						LTDC_Draw_Point(y,x,0xFFFF);	  
		    }
       }
     }
		for(y=160*j+80;y<160*j+160;y++)
	{
			for(i=0;i<6;i++)      
     {
				for(x=160*i;x<160*i+80;x++)
        {      
						LTDC_Draw_Point(y,x,0xFFFF);	  
		    }
				for(x=160*i+80;x<160*i+160;x++)
				{   		
						LTDC_Draw_Point(y,x,0x0000);  
				}
			}
		}
  }
}

//ʾcrosstalk
//LCDֱΪHVڷСΪ͡
void display_crosstalk(u16 H, u16 V,u8 M, u8 N)
	
{ 
	 u16 x,y;
	for(y=0;y<((V-N)/2);y++)
		for(x=0;x<H;x++)
		{
			LTDC_Draw_Point(x,y,0x8410);			
		}
	for(y=((V-N)/2);y<(((V-N)/2)+N);y++)
		{
			for(x=0;x<((H-M)/2);x++)
			{
				LTDC_Draw_Point(x,y,0x8410);				
			}		
			for(x=((H-M)/2);x<(((H-M)/2)+M);x++)
			{
				LTDC_Draw_Point(x,y,0x0000);				
			}
			
			for(x=(((H-M)/2)+M);x<H;x++)
			{
				LTDC_Draw_Point(x,y,0x8410);				
			}
		}
		
	for(y=(((V-N)/2)+N);y<V;y++)
		for(x=0;x<H;x++)
		{
			LTDC_Draw_Point(x,y,0x8410);			
		}	
}

//ʾˮƽҽ׻
void display_gray_H(void)
{
	u16 x,y,i ;
	u8 R5,G6,B5,H8,L8;
	u16 color;
	R5=0;
	G6=0;
	B5=0;
	color=0;
	H8=((R5<<3)|(G6>>3));
	L8=((G6<<5)|B5);	
    for( y = 0; y < 32; y++ )
    {
      {
        for(i	=	0;i	<	15;	i++)
    	     for( x = 0; x < 800; x++ )
    	      {
					LTDC_Draw_Point(x,(y*15+i),color);
				}
      }
    	
		R5=R5+1;
		G6=G6+2;
		B5=B5+1;     
		H8=((R5<<3)|(G6>>3));  	   
		L8=((G6<<5)|B5);	 
		color=((H8<<8)|L8);
    }
}



//ʾֱҽ׻
void display_gray_V(void)
{
	u16 x,y,i ;
	u8 R5,G6,B5,H8,L8;
	u16 color;
	R5=0;
	G6=0;
	B5=0;
	color=0;
	H8=((R5<<3)|(G6>>3));
	L8=((G6<<5)|B5);	
    for( x = 0; x < 32; x++ )
   {
      {
        for(i	=	0;i	<	25;	i++)
    	     for( y = 0; y < 480; y++ )
    	       {
					LTDC_Draw_Point((x*25+i),y,color);
				}
      }
    	
		R5=R5+1;
		G6=G6+2;
		B5=B5+1;     
		H8=((R5<<3)|(G6>>3));  	   
		L8=((G6<<5)|B5);	 
		color=((H8<<8)|L8);
    }
}






#if 1

extern unsigned char girl_800480[];

void display_pic(void)
{
	u16 x,y;
	int p=0;
	u8 a,b;
	u16 color;
	for(y=0;y<480;y++)    
     for(x=0;x<800;x++)
     {
				a=(girl_800480[p]);
				b=(girl_800480[p+1]);
				color=((a<<8)|b);
				LTDC_Draw_Point(x,y,color);
				p=p+2;
     }  
}


#endif








//ٻ
//x,y:
//color:ɫ
void LCD_Fast_DrawPoint(u16 x,u16 y,u32 color)
{	   
	if(lcdltdc.pwidth!=0)//RGB
	{
		LTDC_Draw_Point(x,y,color);
		return;
	}else if(lcddev.id==0X9341||lcddev.id==0X5310)
	{
		LCD_WR_REG(lcddev.setxcmd); 
		LCD_WR_DATA(x>>8);LCD_WR_DATA(x&0XFF);  			 
		LCD_WR_REG(lcddev.setycmd); 
		LCD_WR_DATA(y>>8);LCD_WR_DATA(y&0XFF); 		 	 
	}else if(lcddev.id==0X5510)
	{
		LCD_WR_REG(lcddev.setxcmd);LCD_WR_DATA(x>>8);  
		LCD_WR_REG(lcddev.setxcmd+1);LCD_WR_DATA(x&0XFF);	  
		LCD_WR_REG(lcddev.setycmd);LCD_WR_DATA(y>>8);  
		LCD_WR_REG(lcddev.setycmd+1);LCD_WR_DATA(y&0XFF); 
	}else if(lcddev.id==0X1963)
	{
		if(lcddev.dir==0)x=lcddev.width-1-x;
		LCD_WR_REG(lcddev.setxcmd); 
		LCD_WR_DATA(x>>8);LCD_WR_DATA(x&0XFF); 		
		LCD_WR_DATA(x>>8);LCD_WR_DATA(x&0XFF); 		
		LCD_WR_REG(lcddev.setycmd); 
		LCD_WR_DATA(y>>8);LCD_WR_DATA(y&0XFF); 		
		LCD_WR_DATA(y>>8);LCD_WR_DATA(y&0XFF); 		
	}		 
	LCD->LCD_REG=lcddev.wramcmd; 
	LCD->LCD_RAM=color; 
}	 
//SSD1963 
//pwm:ȼ,0~100.ԽԽ.
void LCD_SSD_BackLightSet(u8 pwm)
{	
	LCD_WR_REG(0xBE);	//PWM
	LCD_WR_DATA(0x05);	//1PWMƵ
	LCD_WR_DATA(pwm*2.55);//2PWMռձ
	LCD_WR_DATA(0x01);	//3C
	LCD_WR_DATA(0xFF);	//4D
	LCD_WR_DATA(0x00);	//5E
	LCD_WR_DATA(0x00);	//6F
}

//LCDʾ
//dir:0,1,
void LCD_Display_Dir(u8 dir)
{
    lcddev.dir=dir;         ///
	if(lcdltdc.pwidth!=0)   //RGB
	{
		LTDC_Display_Dir(dir);
		lcddev.width=lcdltdc.width;
		lcddev.height=lcdltdc.height;
		return;
	}
	if(dir==0)			//
	{
		lcddev.width=240;
		lcddev.height=320;
		if(lcddev.id==0X9341||lcddev.id==0X5310)
		{
			lcddev.wramcmd=0X2C;
	 		lcddev.setxcmd=0X2A;
			lcddev.setycmd=0X2B;  	 
			if(lcddev.id==0X5310)
			{
				lcddev.width=320;
				lcddev.height=480;
			}
		}else if(lcddev.id==0x5510)
		{
			lcddev.wramcmd=0X2C00;
	 		lcddev.setxcmd=0X2A00;
			lcddev.setycmd=0X2B00; 
			lcddev.width=480;
			lcddev.height=800;
		}else if(lcddev.id==0X1963)
		{
			lcddev.wramcmd=0X2C;	//дGRAMָ 
			lcddev.setxcmd=0X2B;	//дXָ
			lcddev.setycmd=0X2A;	//дYָ
			lcddev.width=480;		//ÿ480
			lcddev.height=800;		//ø߶800  
		}
	}else 				//
	{	  				
		lcddev.width=320;
		lcddev.height=240;
		if(lcddev.id==0X9341||lcddev.id==0X5310)
		{
			lcddev.wramcmd=0X2C;
	 		lcddev.setxcmd=0X2A;
			lcddev.setycmd=0X2B;  	 
		}else if(lcddev.id==0x5510)
		{
			lcddev.wramcmd=0X2C00;
	 		lcddev.setxcmd=0X2A00;
			lcddev.setycmd=0X2B00; 
			lcddev.width=800;
			lcddev.height=480;
		}else if(lcddev.id==0X1963)
		{
			lcddev.wramcmd=0X2C;	//дGRAMָ 
			lcddev.setxcmd=0X2A;	//дXָ
			lcddev.setycmd=0X2B;	//дYָ
			lcddev.width=800;		//ÿ800
			lcddev.height=480;		//ø߶480  
		}
		if(lcddev.id==0X5310)
		{ 	 
			lcddev.width=480;
			lcddev.height=320; 			
		}
	} 
	LCD_Scan_Dir(DFT_SCAN_DIR);	//Ĭɨ跽
}	 
//ô(RGBЧ),Զû굽Ͻ(sx,sy).
//sx,sy:ʼ(Ͻ)
//width,height:ڿȺ͸߶,0!!
//С:width*height. 
void LCD_Set_Window(u16 sx,u16 sy,u16 width,u16 height)
{     
	u16 twidth,theight;
	twidth=sx+width-1;
	theight=sy+height-1;
	if(lcddev.id==0X9341||lcddev.id==0X5310||(lcddev.dir==1&&lcddev.id==0X1963))
	{
		LCD_WR_REG(lcddev.setxcmd); 
		LCD_WR_DATA(sx>>8); 
		LCD_WR_DATA(sx&0XFF);	 
		LCD_WR_DATA(twidth>>8); 
		LCD_WR_DATA(twidth&0XFF);  
		LCD_WR_REG(lcddev.setycmd); 
		LCD_WR_DATA(sy>>8); 
		LCD_WR_DATA(sy&0XFF); 
		LCD_WR_DATA(theight>>8); 
		LCD_WR_DATA(theight&0XFF); 
	}else if(lcddev.id==0X1963)//1963⴦
	{
		sx=lcddev.width-width-sx; 
		height=sy+height-1; 
		LCD_WR_REG(lcddev.setxcmd); 
		LCD_WR_DATA(sx>>8); 
		LCD_WR_DATA(sx&0XFF);	 
		LCD_WR_DATA((sx+width-1)>>8); 
		LCD_WR_DATA((sx+width-1)&0XFF);  
		LCD_WR_REG(lcddev.setycmd); 
		LCD_WR_DATA(sy>>8); 
		LCD_WR_DATA(sy&0XFF); 
		LCD_WR_DATA(height>>8); 
		LCD_WR_DATA(height&0XFF); 		
	}else if(lcddev.id==0X5510)
	{
		LCD_WR_REG(lcddev.setxcmd);LCD_WR_DATA(sx>>8);  
		LCD_WR_REG(lcddev.setxcmd+1);LCD_WR_DATA(sx&0XFF);	  
		LCD_WR_REG(lcddev.setxcmd+2);LCD_WR_DATA(twidth>>8);   
		LCD_WR_REG(lcddev.setxcmd+3);LCD_WR_DATA(twidth&0XFF);   
		LCD_WR_REG(lcddev.setycmd);LCD_WR_DATA(sy>>8);   
		LCD_WR_REG(lcddev.setycmd+1);LCD_WR_DATA(sy&0XFF);  
		LCD_WR_REG(lcddev.setycmd+2);LCD_WR_DATA(theight>>8);   
		LCD_WR_REG(lcddev.setycmd+3);LCD_WR_DATA(theight&0XFF);  
	} 
}

//SRAMײʱʹܣŷ
//˺ᱻHAL_SRAM_Init()
//hsram:SRAM
void HAL_SRAM_MspInit(SRAM_HandleTypeDef *hsram)
{
    GPIO_InitTypeDef GPIO_Initure;
	
	__HAL_RCC_FMC_CLK_ENABLE();				//ʹFMCʱ
	__HAL_RCC_GPIOD_CLK_ENABLE();			//ʹGPIODʱ
	__HAL_RCC_GPIOE_CLK_ENABLE();			//ʹGPIOEʱ
	
	//ʼPD0,1,4,5,7,8,9,10,13,14,15
	GPIO_Initure.Pin=GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_7|GPIO_PIN_8|\
                     GPIO_PIN_9|GPIO_PIN_10|GPIO_PIN_13|GPIO_PIN_14|GPIO_PIN_15;
	GPIO_Initure.Mode=GPIO_MODE_AF_PP; 		//
	GPIO_Initure.Pull=GPIO_PULLUP;			//
	GPIO_Initure.Speed=GPIO_SPEED_HIGH;		//
	GPIO_Initure.Alternate=GPIO_AF12_FMC;	//ΪFMC
	HAL_GPIO_Init(GPIOD,&GPIO_Initure);
	
	//ʼPE7,8,9,10,11,12,13,14,15
	GPIO_Initure.Pin=GPIO_PIN_7|GPIO_PIN_8|GPIO_PIN_9|GPIO_PIN_10|GPIO_PIN_11|\
                     GPIO_PIN_12|GPIO_PIN_13|GPIO_PIN_14|GPIO_PIN_15;
	HAL_GPIO_Init(GPIOE,&GPIO_Initure);
}
        
//ʼlcd
//óʼԳʼͺŵLCD(.cļǰ)
void LCD_Init(void)
{ 	  

	LTDC_Init();
	LCD_Display_Dir(1);		//ĬΪ
	LCD_LED=1;				//
	LCD_Clear(WHITE);
}  
//
//color:Ҫɫ
void LCD_Clear(u32 color)
{
	u32 index=0;      
	u32 totalpoint=lcddev.width;
	if(lcdltdc.pwidth!=0)	//RGB
	{
		LTDC_Clear(color);
	}else
	{
		totalpoint*=lcddev.height; 			//õܵ
		LCD_SetCursor(0x00,0x0000);			//ùλ 
		LCD_WriteRAM_Prepare();     		//ʼдGRAM	 	  
		for(index=0;index<totalpoint;index++)
		{
			LCD->LCD_RAM=color;	
		}
	}
}  
//ָ䵥ɫ
//(sx,sy),(ex,ey):ζԽ,СΪ:(ex-sx+1)*(ey-sy+1)   
//color:Ҫɫ
void LCD_Fill(u16 sx,u16 sy,u16 ex,u16 ey,u32 color)
{          
	u16 i,j;
	u16 xlen=0;
	if(lcdltdc.pwidth!=0)	//RGB
	{
		LTDC_Fill(sx,sy,ex,ey,color);
	}else
	{	
		xlen=ex-sx+1;	 
		for(i=sy;i<=ey;i++)
		{
			LCD_SetCursor(sx,i);      				//ùλ 
			LCD_WriteRAM_Prepare();     			//ʼдGRAM	  
			for(j=0;j<xlen;j++)LCD->LCD_RAM=color;	//ʾɫ 	    
		} 
	}
}  
//ָָɫ			 
//(sx,sy),(ex,ey):ζԽ,СΪ:(ex-sx+1)*(ey-sy+1)   
//color:Ҫɫ
void LCD_Color_Fill(u16 sx,u16 sy,u16 ex,u16 ey,u16 *color)
{  
	u16 height,width;
	u16 i,j;
	if(lcdltdc.pwidth!=0)	//RGB
	{
		LTDC_Color_Fill(sx,sy,ex,ey,color);
	}else
	{
		width=ex-sx+1; 			//õĿ
		height=ey-sy+1;			//߶
		for(i=0;i<height;i++)
		{
			LCD_SetCursor(sx,sy+i);   	//ùλ 
			LCD_WriteRAM_Prepare();     //ʼдGRAM
			for(j=0;j<width;j++)LCD->LCD_RAM=color[i*width+j];//д 
		}
	}	
}  
//
//x1,y1:
//x2,y2:յ  
void LCD_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2)
{
	u16 t; 
	int xerr=0,yerr=0,delta_x,delta_y,distance; 
	int incx,incy,uRow,uCol; 
	delta_x=x2-x1; // 
	delta_y=y2-y1; 
	uRow=x1; 
	uCol=y1; 
	if(delta_x>0)incx=1; //õ 
	else if(delta_x==0)incx=0;//ֱ 
	else {incx=-1;delta_x=-delta_x;} 
	if(delta_y>0)incy=1; 
	else if(delta_y==0)incy=0;//ˮƽ 
	else{incy=-1;delta_y=-delta_y;} 
	if( delta_x>delta_y)distance=delta_x; //ѡȡ 
	else distance=delta_y; 
	for(t=0;t<=distance+1;t++ )// 
	{  
		LCD_DrawPoint(uRow,uCol);// 
		xerr+=delta_x ; 
		yerr+=delta_y ; 
		if(xerr>distance) 
		{ 
			xerr-=distance; 
			uRow+=incx; 
		} 
		if(yerr>distance) 
		{ 
			yerr-=distance; 
			uCol+=incy; 
		} 
	}  
}    
//	  
//(x1,y1),(x2,y2):εĶԽ
void LCD_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2)
{
	LCD_DrawLine(x1,y1,x2,y1);
	LCD_DrawLine(x1,y1,x1,y2);
	LCD_DrawLine(x1,y2,x2,y2);
	LCD_DrawLine(x2,y1,x2,y2);
}
//ָλûһָСԲ
//(x,y):ĵ
//r    :뾶
void LCD_Draw_Circle(u16 x0,u16 y0,u8 r)
{
	int a,b;
	int di;
	a=0;b=r;	  
	di=3-(r<<1);             //ж¸λõı־
	while(a<=b)
	{
		LCD_DrawPoint(x0+a,y0-b);             //5
 		LCD_DrawPoint(x0+b,y0-a);             //0           
		LCD_DrawPoint(x0+b,y0+a);             //4               
		LCD_DrawPoint(x0+a,y0+b);             //6 
		LCD_DrawPoint(x0-a,y0+b);             //1       
 		LCD_DrawPoint(x0-b,y0+a);             
		LCD_DrawPoint(x0-a,y0-b);             //2             
  		LCD_DrawPoint(x0-b,y0-a);             //7     	         
		a++;
		//ʹBresenham㷨Բ     
		if(di<0)di +=4*a+6;	  
		else
		{
			di+=10+4*(a-b);   
			b--;
		} 						    
	}
} 									  
//ָλʾһַ
//x,y:ʼ
//num:Ҫʾַ:" "--->"~"
//size:С 12/16/24/32
//mode:ӷʽ(1)Ƿǵӷʽ(0)
void LCD_ShowChar(u16 x,u16 y,u8 num,u8 size,u8 mode)
{  							  
    u8 temp,t1,t;
	u16 y0=y;
	u8 csize=(size/8+((size%8)?1:0))*(size/2);		//õһַӦռֽ	
 	num=num-' ';//õƫƺֵASCIIֿǴӿոʼȡģ-' 'ǶӦַֿ⣩
	for(t=0;t<csize;t++)
	{   
		if(size==12)temp=asc2_1206[num][t]; 	 	//1206
		else if(size==16)temp=asc2_1608[num][t];	//1608
		else if(size==24)temp=asc2_2412[num][t];	//2412
		else if(size==32)temp=asc2_3216[num][t];	//3216
		else return;								//ûеֿ
		for(t1=0;t1<8;t1++)
		{			    
			if(temp&0x80)LCD_Fast_DrawPoint(x,y,POINT_COLOR);
			else if(mode==0)LCD_Fast_DrawPoint(x,y,BACK_COLOR);
			temp<<=1;
			y++;
			if(y>=lcddev.height)return;		//
			if((y-y0)==size)
			{
				y=y0;
				x++;
				if(x>=lcddev.width)return;	//
				break;
			}
		}  	 
	}  	    	   	 	  
}   
//m^n
//ֵ:m^nη.
u32 LCD_Pow(u8 m,u8 n)
{
	u32 result=1;	 
	while(n--)result*=m;    
	return result;
}			 
//ʾ,λΪ0,ʾ
//x,y :	 
//len :ֵλ
//size:С
//color:ɫ 
//num:ֵ(0~4294967295);	 
void LCD_ShowNum(u16 x,u16 y,u32 num,u8 len,u8 size)
{         	
	u8 t,temp;
	u8 enshow=0;						   
	for(t=0;t<len;t++)
	{
		temp=(num/LCD_Pow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				LCD_ShowChar(x+(size/2)*t,y,' ',size,0);
				continue;
			}else enshow=1; 
		 	 
		}
	 	LCD_ShowChar(x+(size/2)*t,y,temp+'0',size,0); 
	}
} 
//ʾ,λΪ0,ʾ
//x,y:
//num:ֵ(0~999999999);	 
//len:(Ҫʾλ)
//size:С
//mode:
//[7]:0,;1,0.
//[6:1]:
//[0]:0,ǵʾ;1,ʾ.
void LCD_ShowxNum(u16 x,u16 y,u32 num,u8 len,u8 size,u8 mode)
{  
	u8 t,temp;
	u8 enshow=0;						   
	for(t=0;t<len;t++)
	{
		temp=(num/LCD_Pow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				if(mode&0X80)LCD_ShowChar(x+(size/2)*t,y,'0',size,mode&0X01);  
				else LCD_ShowChar(x+(size/2)*t,y,' ',size,mode&0X01);  
 				continue;
			}else enshow=1; 
		 	 
		}
	 	LCD_ShowChar(x+(size/2)*t,y,temp+'0',size,mode&0X01); 
	}
} 
//ʾַ
//x,y:
//width,height:С  
//size:С
//*p:ַʼַ		  
void LCD_ShowString(u16 x,u16 y,u16 width,u16 height,u8 size,u8 *p)
{         
	u8 x0=x;
	width+=x;
	height+=y;
    while((*p<='~')&&(*p>=' '))//жǲǷǷַ!
    {       
        if(x>=width){x=x0;y+=size;}
        if(y>=height)break;//˳
        LCD_ShowChar(x,y,*p,size,0);
        x+=size/2;
        p++;
    }  
}































