#include "ltdc.h"
#include "lcd.h"
//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//ALIENTEK STM32F429
//LTDC	   
//ԭ@ALIENTEK
//̳:www.openedv.com
//:2016/1/6
//汾V1.0
//ȨУؾ
//Copyright(C) ӿƼ޹˾ 2014-2024
//All rights reserved									  
////////////////////////////////////////////////////////////////////////////////// 	
LTDC_HandleTypeDef  LTDC_Handler;	      //LTDC
DMA2D_HandleTypeDef DMA2D_Handler; 	    //DMA2D

//ݲͬɫʽ,֡
#if LCD_PIXFORMAT==LCD_PIXFORMAT_ARGB8888||LCD_PIXFORMAT==LCD_PIXFORMAT_RGB888
	u32 ltdc_lcd_framebuf[1280][800] __attribute__((at(LCD_FRAME_BUF_ADDR)));	//ֱʱ,LCD֡С
#else
	u16 ltdc_lcd_framebuf[1280][800] __attribute__((at(LCD_FRAME_BUF_ADDR)));	//ֱʱ,LCD֡С
#endif

u32 *ltdc_framebuf[2];					//LTDC LCDָ֡,ָӦСڴ
_ltdc_dev lcdltdc;						//LCD LTDCҪ

//LCD
//lcd_switch:1 ,0ر
void LTDC_Switch(u8 sw)
{
	if(sw==1) __HAL_LTDC_ENABLE(&LTDC_Handler);
	else if(sw==0)__HAL_LTDC_DISABLE(&LTDC_Handler);
}

//ָ
//layerx:,0,һ; 1,ڶ
//sw:1 ;0ر
void LTDC_Layer_Switch(u8 layerx,u8 sw)
{
	if(sw==1) __HAL_LTDC_LAYER_ENABLE(&LTDC_Handler,layerx);
	else if(sw==0) __HAL_LTDC_LAYER_DISABLE(&LTDC_Handler,layerx);
	__HAL_LTDC_RELOAD_CONFIG(&LTDC_Handler);
}

//ѡ
//layerx:;0,һ;1,ڶ;
void LTDC_Select_Layer(u8 layerx)
{
	lcdltdc.activelayer=layerx;
}

//LCDʾ
//dir:0,1,
void LTDC_Display_Dir(u8 dir)
{
    lcdltdc.dir=dir; 	//ʾ
	if(dir==0)			//
	{
		lcdltdc.width=lcdltdc.pheight;
		lcdltdc.height=lcdltdc.pwidth;	
	}else if(dir==1)	//
	{
		lcdltdc.width=lcdltdc.pwidth;
		lcdltdc.height=lcdltdc.pheight;
	}
}

//㺯
//x,y:д
//color:ɫֵ
void LTDC_Draw_Point(u16 x,u16 y,u32 color)
{ 
#if LCD_PIXFORMAT==LCD_PIXFORMAT_ARGB8888||LCD_PIXFORMAT==LCD_PIXFORMAT_RGB888
	if(lcdltdc.dir)	//
	{
        *(u32*)((u32)ltdc_framebuf[lcdltdc.activelayer]+lcdltdc.pixsize*(lcdltdc.pwidth*y+x))=color;
	}else 			//
	{
        *(u32*)((u32)ltdc_framebuf[lcdltdc.activelayer]+lcdltdc.pixsize*(lcdltdc.pwidth*(lcdltdc.pheight-x)+y))=color; 
	}
#else
	if(lcdltdc.dir)	//
	{
        *(u16*)((u32)ltdc_framebuf[lcdltdc.activelayer]+lcdltdc.pixsize*(lcdltdc.pwidth*y+x))=color;
	}else 			//
	{
        *(u16*)((u32)ltdc_framebuf[lcdltdc.activelayer]+lcdltdc.pixsize*(lcdltdc.pwidth*(lcdltdc.pheight-x-1)+y))=color; 
	}
#endif
}

//㺯
//x,y:ȡ
//ֵ:ɫֵ
u32 LTDC_Read_Point(u16 x,u16 y)
{ 
#if LCD_PIXFORMAT==LCD_PIXFORMAT_ARGB8888||LCD_PIXFORMAT==LCD_PIXFORMAT_RGB888
	if(lcdltdc.dir)	//
	{
		return *(u32*)((u32)ltdc_framebuf[lcdltdc.activelayer]+lcdltdc.pixsize*(lcdltdc.pwidth*y+x));
	}else 			//
	{
		return *(u32*)((u32)ltdc_framebuf[lcdltdc.activelayer]+lcdltdc.pixsize*(lcdltdc.pwidth*(lcdltdc.pheight-x)+y)); 
	}
#else
	if(lcdltdc.dir)	//
	{
		return *(u16*)((u32)ltdc_framebuf[lcdltdc.activelayer]+lcdltdc.pixsize*(lcdltdc.pwidth*y+x));
	}else 			//
	{
		return *(u16*)((u32)ltdc_framebuf[lcdltdc.activelayer]+lcdltdc.pixsize*(lcdltdc.pwidth*(lcdltdc.pheight-x-1)+y)); 
	}
#endif 
}

//LTDC,DMA2D
//(sx,sy),(ex,ey):ζԽ,СΪ:(ex-sx+1)*(ey-sy+1)   
//color:Ҫɫ
//ʱҪƵĵ亯Ϊٶȣ亯üĴ汾
//жӦĿ⺯汾Ĵ롣
void LTDC_Fill(u16 sx,u16 sy,u16 ex,u16 ey,u32 color)
{ 
	u32 psx,psy,pex,pey;	//LCDΪ׼ϵ,仯仯
	u32 timeout=0; 
	u16 offline;
	u32 addr; 
	//ϵת
	if(lcdltdc.dir)	//
	{
		psx=sx;psy=sy;
		pex=ex;pey=ey;
	}else			//
	{
		psx=sy;psy=lcdltdc.pheight-ex-1;
		pex=ey;pey=lcdltdc.pheight-sx-1;
	}
	offline=lcdltdc.pwidth-(pex-psx+1);
	addr=((u32)ltdc_framebuf[lcdltdc.activelayer]+lcdltdc.pixsize*(lcdltdc.pwidth*psy+psx));
	__HAL_RCC_DMA2D_CLK_ENABLE();	//ʹDM2Dʱ
	DMA2D->CR&=~(DMA2D_CR_START);	//ֹͣDMA2D
	DMA2D->CR=DMA2D_R2M;			//Ĵ洢ģʽ
	DMA2D->OPFCCR=LCD_PIXFORMAT;	//ɫʽ
	DMA2D->OOR=offline;				//ƫ 

	DMA2D->OMAR=addr;				//洢ַ
	DMA2D->NLR=(pey-psy+1)|((pex-psx+1)<<16);	//趨Ĵ
	DMA2D->OCOLR=color;						//趨ɫĴ 
	DMA2D->CR|=DMA2D_CR_START;				//DMA2D
	while((DMA2D->ISR&(DMA2D_FLAG_TC))==0)	//ȴ
	{
		timeout++;
		if(timeout>0X1FFFFF)break;	//ʱ˳
	} 
	DMA2D->IFCR|=DMA2D_FLAG_TC;		//ɱ־ 		
}
//ָ䵥ɫ
//(sx,sy),(ex,ey):ζԽ,СΪ:(ex-sx+1)*(ey-sy+1)   
//color:Ҫɫ
//void LTDC_Fill(u16 sx,u16 sy,u16 ex,u16 ey,u32 color)
//{
//	u32 psx,psy,pex,pey;	//LCDΪ׼ϵ,仯仯
//	u32 timeout=0; 
//	u16 offline;
//	u32 addr;  
//    if(ex>=lcdltdc.width)ex=lcdltdc.width-1;
//	if(ey>=lcdltdc.height)ey=lcdltdc.height-1;
//	//ϵת
//	if(lcdltdc.dir)	//
//	{
//		psx=sx;psy=sy;
//		pex=ex;pey=ey;
//	}else			//
//	{
//		psx=sy;psy=lcdltdc.pheight-ex-1;
//		pex=ey;pey=lcdltdc.pheight-sx-1;
//	}
//	offline=lcdltdc.pwidth-(pex-psx+1);
//	addr=((u32)ltdc_framebuf[lcdltdc.activelayer]+lcdltdc.pixsize*(lcdltdc.pwidth*psy+psx));
//    if(LCD_PIXFORMAT==LCD_PIXEL_FORMAT_RGB565)  //RGB565ʽĻҪɫת16bitתΪ32bit
//    {
//        color=((color&0X0000F800)<<8)|((color&0X000007E0)<<5)|((color&0X0000001F)<<3);
//    }
//	//DMA2Dģʽ
//	DMA2D_Handler.Instance=DMA2D;
//	DMA2D_Handler.Init.Mode=DMA2D_R2M;			//ڴ浽洢ģʽ
//	DMA2D_Handler.Init.ColorMode=LCD_PIXFORMAT;	//ɫʽ
//	DMA2D_Handler.Init.OutputOffset=offline;		//ƫ 
//	HAL_DMA2D_Init(&DMA2D_Handler);              //ʼDMA2D
//    HAL_DMA2D_ConfigLayer(&DMA2D_Handler,lcdltdc.activelayer); //
//    HAL_DMA2D_Start(&DMA2D_Handler,color,(u32)addr,pex-psx+1,pey-psy+1);//
//    HAL_DMA2D_PollForTransfer(&DMA2D_Handler,1000);//
//    while((__HAL_DMA2D_GET_FLAG(&DMA2D_Handler,DMA2D_FLAG_TC)==0)&&(timeout<0X5000))//ȴDMA2D
//    {
//        timeout++;
//    }
//    __HAL_DMA2D_CLEAR_FLAG(&DMA2D_Handler,DMA2D_FLAG_TC);       //ɱ־
//}

//ָָɫ,DMA2D	
//˺֧u16,RGB565ʽɫ.
//(sx,sy),(ex,ey):ζԽ,СΪ:(ex-sx+1)*(ey-sy+1)  
//ע:sx,ex,ܴlcddev.width-1;sy,ey,ܴlcddev.height-1!!!
//color:Ҫɫ׵ַ
void LTDC_Color_Fill(u16 sx,u16 sy,u16 ex,u16 ey,u16 *color)
{
	u32 psx,psy,pex,pey;	//LCDΪ׼ϵ,仯仯
	u32 timeout=0; 
	u16 offline;
	u32 addr; 
	//ϵת
	if(lcdltdc.dir)	//
	{
		psx=sx;psy=sy;
		pex=ex;pey=ey;
	}else			//
	{
		psx=sy;psy=lcdltdc.pheight-ex-1;
		pex=ey;pey=lcdltdc.pheight-sx-1;
	}
	offline=lcdltdc.pwidth-(pex-psx+1);
	addr=((u32)ltdc_framebuf[lcdltdc.activelayer]+lcdltdc.pixsize*(lcdltdc.pwidth*psy+psx));
	__HAL_RCC_DMA2D_CLK_ENABLE();	//ʹDM2Dʱ
	DMA2D->CR&=~(DMA2D_CR_START);	//ֹͣDMA2D
	DMA2D->CR=DMA2D_M2M;			//洢洢ģʽ
	DMA2D->FGPFCCR=LCD_PIXFORMAT;	//ɫʽ
	DMA2D->FGOR=0;					//ǰƫΪ0
	DMA2D->OOR=offline;				//ƫ 

	DMA2D->FGMAR=(u32)color;		//Դַ
	DMA2D->OMAR=addr;				//洢ַ
	DMA2D->NLR=(pey-psy+1)|((pex-psx+1)<<16);	//趨Ĵ 
	DMA2D->CR|=DMA2D_CR_START;					//DMA2D
	while((DMA2D->ISR&(DMA2D_FLAG_TC))==0)		//ȴ
	{
		timeout++;
		if(timeout>0X1FFFFF)break;	//ʱ˳
	} 
	DMA2D->IFCR|=DMA2D_FLAG_TC;				//ɱ־  	
}  

//LCD
//color:ɫֵ
void LTDC_Clear(u32 color)
{
	LTDC_Fill(0,0,lcdltdc.width-1,lcdltdc.height-1,color);
}

//LTDCʱ(Fdclk)ú
//Fvco=Fin*pllsain; 
//Fdclk=Fvco/pllsair/2*2^pllsaidivr=Fin*pllsain/pllsair/2*2^pllsaidivr;

//Fvco:VCOƵ
//Fin:ʱƵһΪ1Mhz(ϵͳʱPLLMƵʱ,ʱͼ)
//pllsain:SAIʱӱƵϵN,ȡֵΧ:50~432.  
//pllsair:SAIʱӵķƵϵR,ȡֵΧ:2~7
//pllsaidivr:LCDʱӷƵϵ,ȡֵΧ:RCC_PLLSAIDIVR_2/4/8/16,ӦƵ2~16 
//:ⲿΪ25M,pllm=25ʱ,Fin=1Mhz.
//:Ҫõ20MLTDCʱ,:pllsain=400,pllsair=5,pllsaidivr=RCC_PLLSAIDIVR_4
//Fdclk=1*400/5/4=400/20=20Mhz
//ֵ:0,ɹ;1,ʧܡ
u8 LTDC_Clk_Set(u32 pllsain,u32 pllsair,u32 pllsaidivr)
{
	RCC_PeriphCLKInitTypeDef PeriphClkIniture;
	
	//LTDCʱӣҪԼʹõLCDֲã
  PeriphClkIniture.PeriphClockSelection=RCC_PERIPHCLK_LTDC;	//LTDCʱ 	
	PeriphClkIniture.PLLSAI.PLLSAIN=pllsain;    
	PeriphClkIniture.PLLSAI.PLLSAIR=pllsair;  
	PeriphClkIniture.PLLSAIDivR=pllsaidivr;
	if(HAL_RCCEx_PeriphCLKConfig(&PeriphClkIniture)==HAL_OK)    //ʱ
    {
        return 0;   //ɹ
    }
    else return 1;  //ʧ    
}

//LTDC,մ,LCDϵΪ׼
//ע:˺LTDC_Layer_Parameter_Config֮.
//layerx:ֵ,0/1.
//sx,sy:ʼ
//width,height:Ⱥ͸߶
void LTDC_Layer_Window_Config(u8 layerx,u16 sx,u16 sy,u16 width,u16 height)
{
    HAL_LTDC_SetWindowPosition(&LTDC_Handler,sx,sy,layerx);   //ôڵλ
    HAL_LTDC_SetWindowSize(&LTDC_Handler,width,height,layerx);//ôڴС    
}

//LTDC,.
//ע:˺,LTDC_Layer_Window_Config֮ǰ.
//layerx:ֵ,0/1.
//bufaddr:ɫ֡ʼַ
//pixformat:ɫʽ.0,ARGB8888;1,RGB888;2,RGB565;3,ARGB1555;4,ARGB4444;5,L8;6;AL44;7;AL88
//alpha:ɫAlphaֵ,0,ȫ͸;255,͸
//alpha0:ĬɫAlphaֵ,0,ȫ͸;255,͸
//bfac1:ϵ1,4(100),㶨Alpha;6(101),Alpha*㶨Alpha
//bfac2:ϵ2,5(101),㶨Alpha;7(111),Alpha*㶨Alpha
//bkcolor:Ĭɫ,32λ,24λЧ,RGB888ʽ
//ֵ:
void LTDC_Layer_Parameter_Config(u8 layerx,u32 bufaddr,u8 pixformat,u8 alpha,u8 alpha0,u8 bfac1,u8 bfac2,u32 bkcolor)
{
	LTDC_LayerCfgTypeDef pLayerCfg;
	
	pLayerCfg.WindowX0=0;                       //ʼX
	pLayerCfg.WindowY0=0;                       //ʼY
	pLayerCfg.WindowX1=lcdltdc.pwidth;          //ֹX
	pLayerCfg.WindowY1=lcdltdc.pheight;         //ֹY
	pLayerCfg.PixelFormat=pixformat;		    //ظʽ
	pLayerCfg.Alpha=alpha;				        //Alphaֵã0~255,255Ϊȫ͸
	pLayerCfg.Alpha0=alpha0;			        //ĬAlphaֵ
	pLayerCfg.BlendingFactor1=(u32)bfac1<<8;    //òϵ
	pLayerCfg.BlendingFactor2=(u32)bfac2<<8;	//òϵ
	pLayerCfg.FBStartAdress=bufaddr;	        //òɫ֡ʼַ
	pLayerCfg.ImageWidth=lcdltdc.pwidth;        //ɫ֡Ŀ    
	pLayerCfg.ImageHeight=lcdltdc.pheight;      //ɫ֡ĸ߶
	pLayerCfg.Backcolor.Red=(u8)(bkcolor&0X00FF0000)>>16;   //ɫɫ
	pLayerCfg.Backcolor.Green=(u8)(bkcolor&0X0000FF00)>>8;  //ɫɫ
	pLayerCfg.Backcolor.Blue=(u8)bkcolor&0X000000FF;        //ɫɫ
	HAL_LTDC_ConfigLayer(&LTDC_Handler,&pLayerCfg,layerx);   //ѡеĲ
}  

//ȡ
//PG6=R7(M0);PI2=G7(M1);PI7=B7(M2);
//M2:M1:M0
//0 :0 :0	//4.3480*272 RGB,ID=0X4342
//0 :0 :1	//7800*480 RGB,ID=0X7084
//0 :1 :0	//71024*600 RGB,ID=0X7016
//0 :1 :1	//71280*800 RGB,ID=0X7018
//1 :0 :0	//81024*768 RGB,ID=0X8017 

//ֵ:LCD ID:0,Ƿ;ֵ,ID;
u16 LTDC_PanelID_Read(void)
{
	u8 idx=0;
    GPIO_InitTypeDef GPIO_Initure;
    __HAL_RCC_GPIOG_CLK_ENABLE();       //ʹGPIOGʱ
	__HAL_RCC_GPIOI_CLK_ENABLE();       //ʹGPIOIʱ
    
    GPIO_Initure.Pin=GPIO_PIN_6;        //PG6
    GPIO_Initure.Mode=GPIO_MODE_INPUT;  //
    GPIO_Initure.Pull=GPIO_PULLUP;      //
    GPIO_Initure.Speed=GPIO_SPEED_HIGH; //
    HAL_GPIO_Init(GPIOG,&GPIO_Initure); //ʼ
    
    GPIO_Initure.Pin=GPIO_PIN_2|GPIO_PIN_7; //PI2,7
    HAL_GPIO_Init(GPIOI,&GPIO_Initure);     //ʼ
    
    idx=(u8)HAL_GPIO_ReadPin(GPIOG,GPIO_PIN_6); //ȡM0
    idx|=(u8)HAL_GPIO_ReadPin(GPIOI,GPIO_PIN_2)<<1;//ȡM1
    idx|=(u8)HAL_GPIO_ReadPin(GPIOI,GPIO_PIN_7)<<2;//ȡM2
	if(idx==0)return 0X4342;	    //4.3,480*272ֱ
	else if(idx==1)return 0X7084;	//7,800*480ֱ
	else if(idx==2)return 0X7016;	//7,1024*600ֱ
	else if(idx==3)return 0X7018;	//7,1280*800ֱ
	else if(idx==4)return 0X8017; 	//8,1024*768ֱ
	else return 0;
}


//LCDʼ
void LTDC_Init(void)
{   
	
	/*
	lcdltdc.pwidth=480;			    //,λ:
	lcdltdc.pheight=272;		    //߶,λ:
	lcdltdc.hsw=1;				    //ˮƽͬ
	lcdltdc.vsw=1;				    //ֱͬ
	lcdltdc.hbp=40;				    //ˮƽ
	lcdltdc.vbp=8;				    //ֱ
	lcdltdc.hfp=5;			    //ˮƽǰ
	lcdltdc.vfp=8;				    //ֱǰ
	*/
	//ST7257 timing
	/*
	lcdltdc.pwidth=480;			    //,λ:
	lcdltdc.pheight=272;		    //߶,λ:
	lcdltdc.hbp=43;				    //ˮƽ
	lcdltdc.hfp=8;			    //ˮƽǰ
	lcdltdc.hsw=4;				    //ˮƽͬ
	lcdltdc.vbp=12;				    //ֱ
	lcdltdc.vfp=8;				    //ֱǰ
	lcdltdc.vsw=4;				    //ֱͬ
	*/
	
	lcdltdc.pwidth=800;			    //,λ:
	lcdltdc.pheight=480;		    //߶,λ:
	lcdltdc.hbp=88;				    	//ˮƽ
	lcdltdc.hfp=40;			    		//ˮƽǰ
	lcdltdc.hsw=48;				    	//ˮƽͬ
	lcdltdc.vbp=32;				    	//ֱ
	lcdltdc.vfp=13;				    	//ֱǰ
	lcdltdc.vsw=3;				    	//ֱͬ
	
	
	//LTDC_Clk_Set(396,5,RCC_PLLSAIDIVR_8); //ʱ 33M(˫,ҪDCLK:18.75Mhz  300/4/4,ŻȽϺ)
	LTDC_Clk_Set(396,3,RCC_PLLSAIDIVR_4); //ʱ 9.9M   396/5/8=9.9MHz
	lcddev.width=lcdltdc.pwidth;
	lcddev.height=lcdltdc.pheight;
    
#if LCD_PIXFORMAT==LCD_PIXFORMAT_ARGB8888||LCD_PIXFORMAT==LCD_PIXFORMAT_RGB888 
	ltdc_framebuf[0]=(u32*)&ltdc_lcd_framebuf;
	lcdltdc.pixsize=4;				//ÿռ4ֽ
#else 
  lcdltdc.pixsize=2;				//ÿռ2ֽ
	ltdc_framebuf[0]=(u32*)&ltdc_lcd_framebuf;
#endif 	
		
    //LTDC
    LTDC_Handler.Instance=LTDC;
    LTDC_Handler.Init.HSPolarity=LTDC_HSPOLARITY_AL;         //ˮƽͬ
    LTDC_Handler.Init.VSPolarity=LTDC_VSPOLARITY_AL;         //ֱͬ
    LTDC_Handler.Init.DEPolarity=LTDC_DEPOLARITY_AL;         //ʹܼ,OK
	//LTDC_Handler.Init.DEPolarity=LTDC_DEPOLARITY_AH;
    LTDC_Handler.Init.PCPolarity=LTDC_PCPOLARITY_IPC;        //ʱӼ,OK
	//LTDC_Handler.Init.PCPolarity=LTDC_PCPOLARITY_IIPC;
    LTDC_Handler.Init.HorizontalSync=lcdltdc.hsw-1;          //ˮƽͬ
    LTDC_Handler.Init.VerticalSync=lcdltdc.vsw-1;            //ֱͬ
    LTDC_Handler.Init.AccumulatedHBP=lcdltdc.hsw+lcdltdc.hbp-1; //ˮƽͬؿ
    LTDC_Handler.Init.AccumulatedVBP=lcdltdc.vsw+lcdltdc.vbp-1; //ֱͬظ߶
    LTDC_Handler.Init.AccumulatedActiveW=lcdltdc.hsw+lcdltdc.hbp+lcdltdc.pwidth-1;//Ч
    LTDC_Handler.Init.AccumulatedActiveH=lcdltdc.vsw+lcdltdc.vbp+lcdltdc.pheight-1;//Ч߶
    LTDC_Handler.Init.TotalWidth=lcdltdc.hsw+lcdltdc.hbp+lcdltdc.pwidth+lcdltdc.hfp-1;   //ܿ
    LTDC_Handler.Init.TotalHeigh=lcdltdc.vsw+lcdltdc.vbp+lcdltdc.pheight+lcdltdc.vfp-1;  //ܸ߶
    LTDC_Handler.Init.Backcolor.Red=0;           //Ļɫ
    LTDC_Handler.Init.Backcolor.Green=0;         //Ļɫ
    LTDC_Handler.Init.Backcolor.Blue=0;          //Ļɫɫ
    HAL_LTDC_Init(&LTDC_Handler);
 	
	//
	LTDC_Layer_Parameter_Config(0,(u32)ltdc_framebuf[0],LCD_PIXFORMAT,255,0,6,7,0X000000);//
	LTDC_Layer_Window_Config(0,0,0,lcdltdc.pwidth,lcdltdc.pheight);	//㴰,LCDϵΪ׼,Ҫ޸!
	
	LTDC_Display_Dir(1);			//Ĭ
	LTDC_Select_Layer(0); 			//ѡ1
    LCD_LED=1;         		        //
	LTDC_Clear(0XFFFFFFFF);			//

}

//LTDCײIOʼʱʹ
//˺ᱻHAL_LTDC_Init()
//hltdc:LTDC
void HAL_LTDC_MspInit(LTDC_HandleTypeDef* hltdc)
{
    GPIO_InitTypeDef GPIO_Initure;
    
    __HAL_RCC_LTDC_CLK_ENABLE();                //ʹLTDCʱ
    __HAL_RCC_DMA2D_CLK_ENABLE();               //ʹDMA2Dʱ
    __HAL_RCC_GPIOB_CLK_ENABLE();               //ʹGPIOBʱ
    __HAL_RCC_GPIOF_CLK_ENABLE();               //ʹGPIOFʱ
    __HAL_RCC_GPIOG_CLK_ENABLE();               //ʹGPIOGʱ
    __HAL_RCC_GPIOH_CLK_ENABLE();               //ʹGPIOHʱ
    __HAL_RCC_GPIOI_CLK_ENABLE();               //ʹGPIOIʱ
    
    //ʼPB5
    GPIO_Initure.Pin=GPIO_PIN_5;                //PB5Ʊ
    GPIO_Initure.Mode=GPIO_MODE_OUTPUT_PP;      //
    GPIO_Initure.Pull=GPIO_PULLUP;              //        
    GPIO_Initure.Speed=GPIO_SPEED_HIGH;         //
    HAL_GPIO_Init(GPIOB,&GPIO_Initure);
    
    //ʼPF10
    GPIO_Initure.Pin=GPIO_PIN_10; 
    GPIO_Initure.Mode=GPIO_MODE_AF_PP;          //
    GPIO_Initure.Pull=GPIO_NOPULL;              
    GPIO_Initure.Speed=GPIO_SPEED_HIGH;         //
    GPIO_Initure.Alternate=GPIO_AF14_LTDC;      //ΪLTDC
    HAL_GPIO_Init(GPIOF,&GPIO_Initure);
    
    //ʼPG6,7,11
    GPIO_Initure.Pin=GPIO_PIN_6|GPIO_PIN_7|GPIO_PIN_11;
    HAL_GPIO_Init(GPIOG,&GPIO_Initure);
    
    //ʼPH9,10,11,12,13,14,15
    GPIO_Initure.Pin=GPIO_PIN_9|GPIO_PIN_10|GPIO_PIN_11|\
                     GPIO_PIN_12|GPIO_PIN_13|GPIO_PIN_14|GPIO_PIN_15;
    HAL_GPIO_Init(GPIOH,&GPIO_Initure);
    
    //ʼPI0,1,2,4,5,6,7,9,10
    GPIO_Initure.Pin=GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_4|GPIO_PIN_5|\
                     GPIO_PIN_6|GPIO_PIN_7|GPIO_PIN_9|GPIO_PIN_10;
					 
	//GPIO_Initure.Pin=GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_4|GPIO_PIN_5|\
                     GPIO_PIN_6|GPIO_PIN_7;				 
					 
    HAL_GPIO_Init(GPIOI,&GPIO_Initure); 
}

