#include "ft5206.h"
#include "touch.h"
#include "ctiic.h"
#include "lcd.h"
#include "usart.h"
#include "delay.h" 
#include "string.h" 
//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//ALIENTEK STM32
//7ݴ-FT5206 	   
//ԭ@ALIENTEK
//̳:www.openedv.com
//:2015/12/28
//汾V1.0
//ȨУؾ
//Copyright(C) ӿƼ޹˾ 2014-2024
//All rights reserved									  
////////////////////////////////////////////////////////////////////////////////// 
 
 
//FT5206дһ
//reg:ʼĴַ
//buf:ݻ
//len:дݳ
//ֵ:0,ɹ;1,ʧ.
u8 FT5206_WR_Reg(u16 reg,u8 *buf,u8 len)
{
	u8 i;
	u8 ret=0;
	CT_IIC_Start();	 
	CT_IIC_Send_Byte(FT_CMD_WR);	//д 	 
	CT_IIC_Wait_Ack(); 	 										  		   
	CT_IIC_Send_Byte(reg&0XFF);   	//͵8λַ
	CT_IIC_Wait_Ack();  
	for(i=0;i<len;i++)
	{	   
    	CT_IIC_Send_Byte(buf[i]);  	//
		ret=CT_IIC_Wait_Ack();
		if(ret)break;  
	}
    CT_IIC_Stop();					//һֹͣ	    
	return ret; 
}
//FT5206һ
//reg:ʼĴַ
//buf:ݻ
//len:ݳ			  
void FT5206_RD_Reg(u16 reg,u8 *buf,u8 len)
{
	u8 i; 
 	CT_IIC_Start();	
 	CT_IIC_Send_Byte(FT_CMD_WR);   	//д 	 
	CT_IIC_Wait_Ack(); 	 										  		   
 	CT_IIC_Send_Byte(reg&0XFF);   	//͵8λַ
	CT_IIC_Wait_Ack();  
 	CT_IIC_Start();  	 	   
	CT_IIC_Send_Byte(FT_CMD_RD);   	//Ͷ		   
	CT_IIC_Wait_Ack();	   
	for(i=0;i<len;i++)
	{	   
    	buf[i]=CT_IIC_Read_Byte(i==(len-1)?0:1); //	  
	} 
    CT_IIC_Stop();//һֹͣ     
} 
//ʼFT5206
//ֵ:0,ʼɹ;1,ʼʧ 
u8 FT5206_Init(void)
{
	u8 temp[2]; 
    GPIO_InitTypeDef GPIO_Initure;
 
    __HAL_RCC_GPIOH_CLK_ENABLE();			//GPIOHʱ
    __HAL_RCC_GPIOI_CLK_ENABLE();			//GPIOIʱ
                
    //PH7
    GPIO_Initure.Pin=GPIO_PIN_7;            //PH7
    GPIO_Initure.Mode=GPIO_MODE_INPUT;      //
    GPIO_Initure.Pull=GPIO_PULLUP;          //
    GPIO_Initure.Speed=GPIO_SPEED_HIGH;     //
    HAL_GPIO_Init(GPIOH,&GPIO_Initure);     //ʼ
            
    //PI8
    GPIO_Initure.Pin=GPIO_PIN_8;            //PI8
    GPIO_Initure.Mode=GPIO_MODE_OUTPUT_PP;  //
    HAL_GPIO_Init(GPIOI,&GPIO_Initure);     //ʼ
        
	CT_IIC_Init();      	//ʼI2C  
	FT_RST=0;				//λ
	delay_ms(20);
 	FT_RST=1;				//ͷŸλ		    
	delay_ms(50);  	
	temp[0]=0;
	FT5206_WR_Reg(FT_DEVIDE_MODE,temp,1);	//ģʽ 
	FT5206_WR_Reg(FT_ID_G_MODE,temp,1);		//ѯģʽ 
	temp[0]=22;								//Чֵ22ԽСԽ	
	FT5206_WR_Reg(FT_ID_G_THGROUP,temp,1);	//ôЧֵ
	temp[0]=12;								//ڣС1214
	FT5206_WR_Reg(FT_ID_G_PERIODACTIVE,temp,1); 
	//ȡ汾ţοֵ0x3003
	FT5206_RD_Reg(FT_ID_G_LIB_VERSION,&temp[0],2);  
	if((temp[0]==0X30&&temp[1]==0X03)||temp[1]==0X01||temp[1]==0X02)//汾:0X3003/0X0001/0X0002
	{
		printf("CTP ID:%x\r\n",((u16)temp[0]<<8)+temp[1]);
		return 0;
	} 
	return 1;
}
const u16 FT5206_TPX_TBL[5]={FT_TP1_REG,FT_TP2_REG,FT_TP3_REG,FT_TP4_REG,FT_TP5_REG};
//ɨ败(òѯʽ)
//mode:0,ɨ.
//ֵ:ǰ״̬.
//0,޴;1,д
u8 FT5206_Scan(u8 mode)
{
	u8 buf[4];
	u8 i=0;
	u8 res=0;
	u8 temp;
	static u8 t=0;//Ʋѯ,ӶCPUռ   
	t++;
	if((t%10)==0||t<10)//ʱ,ÿ10CTP_Scanż1,ӶʡCPUʹ
	{
		FT5206_RD_Reg(FT_REG_NUM_FINGER,&mode,1);//ȡ״̬  
		if((mode&0XF)&&((mode&0XF)<6))
		{
			temp=0XFF<<(mode&0XF);//ĸתΪ1λ,ƥtp_dev.sta 
			tp_dev.sta=(~temp)|TP_PRES_DOWN|TP_CATH_PRES; 
			for(i=0;i<5;i++)
			{
				if(tp_dev.sta&(1<<i))		//Ч?
				{
					FT5206_RD_Reg(FT5206_TPX_TBL[i],buf,4);	//ȡXYֵ 
					if(tp_dev.touchtype&0X01)//
					{
						tp_dev.y[i]=((u16)(buf[0]&0X0F)<<8)+buf[1];
						tp_dev.x[i]=((u16)(buf[2]&0X0F)<<8)+buf[3];
					}else
					{
						
						/*
						tp_dev.x[i]=lcddev.width-(((u16)(buf[0]&0X0F)<<8)+buf[1]);
						tp_dev.y[i]=((u16)(buf[2]&0X0F)<<8)+buf[3];
						*/
						
						tp_dev.y[i]=((u16)(buf[0]&0X0F)<<8)+buf[1];
						tp_dev.x[i]=((u16)(buf[2]&0X0F)<<8)+buf[3];
						
					}  
					if((buf[0]&0XF0)!=0X80)tp_dev.x[i]=tp_dev.y[i]=0;//contact¼ΪЧ
					printf("x[%d]:%d,y[%d]:%d\r\n",i,tp_dev.x[i],i,tp_dev.y[i]);
				}			
			} 
			res=1;
			if(tp_dev.x[0]==0 && tp_dev.y[0]==0)mode=0;	//ݶ0,Դ˴
			t=0;		//һ,10,Ӷ
		}
	}
	if((mode&0X1F)==0)//޴㰴
	{ 
		if(tp_dev.sta&TP_PRES_DOWN)	//֮ǰǱµ
		{
			tp_dev.sta&=~(1<<7);	//ǰɿ
		}else						       //֮ǰûб
		{ 
			tp_dev.x[0]=0xffff;
			tp_dev.y[0]=0xffff;
			tp_dev.sta&=0XE0;	//Ч	
		}	 
	} 	
	if(t>240)t=10;//´10ʼ
	return res;
}
 



























